diff -rNu cryptsetup-1.0.6~pre1.orig/debian/control cryptsetup-1.0.6~pre1/debian/control
--- cryptsetup-1.0.6~pre1.orig/debian/control	2008-02-16 02:05:16.000000000 +0100
+++ cryptsetup-1.0.6~pre1/debian/control	2008-02-16 02:05:45.000000000 +0100
@@ -12,7 +12,7 @@
 Package: cryptsetup
 Architecture: any
 Depends: ${shlibs:Depends}, dmsetup
-Suggests: udev, initramfs-tools (>= 0.91) | linux-initramfs-tool, dosfstools
+Suggests: udev, initramfs-tools (>= 0.91) | linux-initramfs-tool, dropbear, dosfstools
 Conflicts: cryptsetup-luks (<= 1.0.1-8), hashalot (<= 0.3-1)
 Replaces: cryptsetup-luks (<= 1.0.1-8)
 Description: configures encrypted block devices
diff -rNu cryptsetup-1.0.6~pre1.orig/debian/initramfs/cryptroot-script cryptsetup-1.0.6~pre1/debian/initramfs/cryptroot-script
--- cryptsetup-1.0.6~pre1.orig/debian/initramfs/cryptroot-script	2008-02-16 02:05:16.000000000 +0100
+++ cryptsetup-1.0.6~pre1/debian/initramfs/cryptroot-script	2008-02-16 02:12:19.000000000 +0100
@@ -195,13 +195,26 @@
 			PASS="$(cat /dev/.initramfs/usplash_outfifo)"
 			echo -n "$PASS" | $cryptcreate > /dev/null 2>&1
 		else
+			cat <<EOF >/sbin/unlock
+#!/bin/sh
+
+$cryptcreate
+if [ -e "/dev/mapper/$crypttarget" ]; then
+	killall cryptsetup
+fi
+EOF
+			chmod 755 /sbin/unlock
 			$cryptcreate < /dev/console > /dev/console 2>&1
 		fi
 
 		if [ $? -ne 0 ]; then
-			echo "cryptsetup: cryptsetup failed, bad password or options?"
-			sleep 3
-			continue
+			if [ -e "/dev/mapper/$crypttarget" ]; then
+				echo "cryptsetup: cryptsetup killed, target unlocked in the background, continuing."
+			else
+				echo "cryptsetup: cryptsetup failed, bad password or options?"
+				sleep 3
+				continue
+			fi
 		elif [ ! -e "$NEWROOT" ]; then
 			echo "cryptsetup: unknown error setting up device mapping"
 			return 1
